/*
 * a.lp_mp3 - Open Source Atmel AVR based MP3 Player
 * Copyright (c) 2003-2004 K. John '2B|!2B' Crispin
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA02111-1307USA
 *
 * Feedback, Bugs.... mail john{AT}phrozen.org
 *
 */ 
 
 
/*
||	TODO:
||		improve inttostr(); 
||		add printf()
||
*/
 
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/pgmspace.h>

#include "types.h"
#include "usart.h"
//							 *0123456789abcdef*
const u08 pms01[] PROGMEM = "starting ...";
const u08 pms02[] PROGMEM = "starting VS1001";
const u08 pms03[] PROGMEM = "VS1001 OK";
const u08 pms04[] PROGMEM = "starting MMC";
const u08 pms05[] PROGMEM = "MMC OK";
const u08 pms06[] PROGMEM = "starting FAT";
const u08 pms07[] PROGMEM = "FAT OK";
const u08 pms08[] PROGMEM = "Starting stream";
const u08 pms09[] PROGMEM = "file end found";
const u08 pms10[] PROGMEM = "playing...";
const u08 pms11[] PROGMEM = "Last File Found";
const u08 pms12[] PROGMEM = "Card Size    : ";
const u08 pms13[] PROGMEM = "Card Name    : ";
const u08 pms14[] PROGMEM = "Sector Count : ";
const u08 pms15[] PROGMEM = "Sec Multiply : ";
const u08 pms16[] PROGMEM = "MMC Response : ";
const u08 pms17[] PROGMEM = "Error R1-init";
const u08 pms18[] PROGMEM = "'2B|!2B'";
const u08 pms19[] PROGMEM = "0 - Sine Off";
const u08 pms20[] PROGMEM = "1 - Sine On";
const u08 pms21[] PROGMEM = "2 - Prnt VSRegs";
const u08 pms22[] PROGMEM = "3 - Audio Data";
const u08 pms23[] PROGMEM = "4 - Decode Time";
const u08 pms24[] PROGMEM = "5 - 5 Beeps";
const u08 pms25[] PROGMEM = "6 - Play";
const u08 pms26[] PROGMEM = ", - Previous";
const u08 pms27[] PROGMEM = ". - Next";
const u08 pms28[] PROGMEM = "- - Vol Down";
const u08 pms29[] PROGMEM = "+ - Vol Up";
const u08 pms30[] PROGMEM = "Found File   : ";
const u08 pms31[] PROGMEM = "Found Vol Id : ";
const u08 pms32[] PROGMEM = "File Size :    ";
const u08 pms33[] PROGMEM = "File Offset :  ";
const u08 pms34[] PROGMEM = "Invalid FS";
const u08 pms35[] PROGMEM = "Filename :     ";
const u08 pms36[] PROGMEM = "Filetype :     ";
const u08 pms37[] PROGMEM = "File           ";
const u08 pms38[] PROGMEM = "Directory      ";
const u08 pms39[] PROGMEM = "Title   : ";
const u08 pms40[] PROGMEM = "Artist  : ";
const u08 pms41[] PROGMEM = "Album   : ";
const u08 pms42[] PROGMEM = "Year    : ";
const u08 pms43[] PROGMEM = "Comment : ";
const u08 pms44[] PROGMEM = "Genre   : ";
const u08 pms45[] PROGMEM = "Shutting Down...";
const u08 pms46[] PROGMEM = "Powering Up...";



PGM_P pgm_strings[46] PROGMEM = {
//PGM_P pgm_strings[34] = {
    pms01,
	pms02,
	pms03,
	pms04,
	pms05,
	pms06,
	pms07,
	pms08,
	pms09,
	pms10,
	pms11,
	pms12,
	pms13,
	pms14,
	pms15,
	pms16,
	pms17,
	pms18,
	pms19,
	pms20,
	pms21,
	pms22,
	pms23,
	pms24,
	pms25,
	pms26,
	pms27,
	pms28,
	pms29,
	pms30,
	pms31,
	pms32,
	pms33,
	pms34,
	pms35,
	pms36, 
	pms37,
	pms38,
	pms39,
	pms40,
	pms41,
	pms42,
	pms43,
	pms44,
	pms45,
	pms46
};


extern void USART_callback(u08 u);

static u08 temp[6];

u08* inttostr ( u16 val) {
	temp[0] = ('0'+(val / 10000));
	temp[1] = ('0'+(val % 10000 / 1000));
	temp[2] = ('0'+(val % 1000 / 100));
	temp[3] = ('0'+(val % 100 / 10));
	temp[4] = ('0'+(val % 10));
	temp[5] = '\0';
	if (temp[0]=='0') temp[0]=' '; else return &temp[0];
	if (temp[1]=='0') temp[1]=' '; else return &temp[1];
	if (temp[2]=='0') temp[2]=' '; else return &temp[2];
	if (temp[3]=='0') temp[3]=' '; else return &temp[3];
	//if (temp[4]=='0') temp[4]=' '; else return &temp[4];
	return &temp[4];
};

void USART_sendint(u16 data){
	USART_sendstring((u08*)inttostr((u16)data),0x00);
};

void USART_sendhex(u08 data){
	u08 data2;
	data2 = (data & 0xf0) >>4;
	if(data2 > 9) data2 += '7'; else data2 += '0';
	USART_send(data2);
	data2 = (data & 0xf);
	if(data2 > 9) data2 += '7'; else data2 += '0';
	USART_send(data2);
	USART_send(' ');
};

void USART_sendhex_16(u16 data){
	USART_sendhex(TO_LOBYTE(data));
	USART_sendhex(LOBYTE(data));
};

// initialise the uart hw
void USART_init(u08 baudrate){
	UBRRL = baudrate;
	/* Enable Receiver and Transmitter */
	UCSRB = (1<<RXEN)|(1<<TXEN);
	/* Set frame format */
	UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);
	UBRRH = 0x00;
	UCSRB = 0x98;
	UCSRC = 0x86;
};

// send a char on the usart
void USART_send(u08 data){
	// wait for txd buffer to be empty
	while ( !( UCSRA & (1<<UDRE) ) );
	// write data  
	UDR = data;
};

// send a char on the usart
void USART_sendspaces(u08 data){
	// wait for txd buffer to be empty
	while(data){
		while ( !( UCSRA & (1<<UDRE) ) );
		// write data  
		UDR = ' ';
		data--;
	};		
};

// send a chunk of memory
void USART_send_mem(u08* data, u16 length){
	while(length){
		USART_send(*data);
		data++;
		length--;
	};
};


// if c == 0x01 then a new line is added
void USART_sendstring (u08 *str, u08 c) {			
 	// parse and send string until end is found
	while ((*str != (u08)(char)0) && (*str != (u08 )(char)10)){
 		USART_send (*str++);
 	};
	if(c ==0x01) USART_newline();
}



// if c == 0x01 then a new line is added
void USART_sendpgmstring (u08 id, u08 c) {			
	u08 *buf;
	u08 t;

	buf = (u08 **)pgm_read_word(pgm_strings + id);
	while ((t = pgm_read_byte(buf)) != '\0' && t != '\n') {
		USART_send (t);
		buf++;
	};
		
	if(c ==0x01) USART_newline();
}


// send the cmd for new line
void USART_newline(void){
	USART_send((u08)0x0a);
	USART_send((u08)0x0d);
};

// send vt100 chars for cls
void USART_clear_screen(void){
	USART_send((u08)0x1B);
	USART_send((u08)'[');
	USART_send((u08)'2');
	USART_send((u08)'J');
};

// this u16 vector gets triggered when we have received data on the uart.
SIGNAL(SIG_UART_RECV){
	u08 c ;
	// get data
	while(!(UCSRA & (1<<RXC))) ;
	c = UDR;
	// process data
	USART_callback(c);	
};

